const DataManagement = require('./DataManagement');
const Frequency = require('./Helper/Frequency');
const MenuAnalytics = require('./Helper/MenuAnalytics');
const ServiceConfig = require('./Helper/ServiceConfig');
const { simpleDate } = require('./Util');
const moment = require('moment');

let tentativasPorDia = 0;
this.numMaxTent = 5 * 100 * 0;
this.melhorPiorCombinação = {};
this.pratsUsedOnMonth = {};
this.pratsUsedOnMonthDAY = [];
this.grpsUsedOnMonth = {};
this.grupoPrato = null;
this.prato_combinacao = null;
this.res_prato_combinacao = null;
this.restIng = {};
this.ingUsed = new Map();
let shuffleArray = (array) => {
  for (let i = array.length - 1; i > 0; i--) {
    const j = Math.floor(Math.random() * (i + 1));
    [array[i], array[j]] = [array[j], array[i]];
  }
  return array;
};

let generateDowShuffled = (utilizacaoPratoSemana) => {
  return ['7', '4', '6', '3', '1', '5', '2'];
  let dowShuffled = [];
  let trad = {
    IND_DOMINGO: {
      now: '7',
      w: 99,
    },
    IND_QUINTA: {
      now: '4',
      w: 99,
    },
    IND_SABADO: {
      now: '6',
      w: 99,
    },
    IND_TERCA: {
      now: '2',
      w: 99,
    },
    IND_SEXTA: {
      now: '5',
      w: 99,
    },
    IND_QUARTA: {
      now: '3',
      w: 99,
    },
    IND_SEGUNDA: {
      now: '1',
      w: 99,
    },
  };
  utilizacaoPratoSemana.forEach((ups) => {
    let upsKeys = Object.keys(ups).filter((key) => key.includes('IND_'));
    upsKeys.forEach((u) => {
      if (ups[u] == 'O') {
        trad[u].w -= 1;
      }
    });
  });
  for (const key in trad) {
    if (trad.hasOwnProperty(key)) {
      dowShuffled.push(trad[key]);
    }
  }

  trad = Object.assign([], dowShuffled);
  dowShuffled = [];
  trad.sort((a, b) => {
    if (a.w < b.w) {
      return -1;
    }
    return 1;
  });
  for (const key in trad) {
    if (trad.hasOwnProperty(key)) {
      dowShuffled.push(parseInt(trad[key].now));
    }
  }
  return dowShuffled;
};

let setPlatesFromConfigOnList = (dia, pratosConfDia) => {
  pratosConfDia.forEach((p) => {
    let prato = p.prato;
    if (prato) {
      let diaPrato = `${dia.dia}${prato}`;

      if (!this.pratsUsedOnMonthDAY.includes(diaPrato)) {
        this.pratsUsedOnMonthDAY.push(diaPrato);

        this.pratsUsedOnMonth[p.prato] = this.pratsUsedOnMonth[p.prato] ? this.pratsUsedOnMonth[p.prato] + 1 : 1;
        this.grpsUsedOnMonth[p.gpprato] = this.grpsUsedOnMonth[p.gpprato] ? this.grpsUsedOnMonth[p.gpprato] + 1 : 1;
      }
    }
  });
};

let getCheapestPlateFromList = (pratos) => {
  pratos.sort((a, b) => {
    if (a.VLR_CUSTO_PRATO > b.VLR_CUSTO_PRATO) {
      return 1;
    }
    return -1;
  });
  return pratos[0];
};

let getRandonPlate = (pratos) => {
  let minOC = 9999;
  pratos.forEach((p) => {
    p.oc = this.pratsUsedOnMonth[p.prato] || 0;
    minOC = minOC > p.oc ? p.oc : minOC;
  });
  let pratFiltred = pratos.filter((p) => {
    if (p.oc == minOC) {
      return p;
    }
  });

  let pratOrigin = null;
  if (pratFiltred.length > 0) {
    pratOrigin = pratFiltred;
  } else {
    pratOrigin = pratos;
  }

  return getCheapestPlateFromList(pratOrigin);
};

let removePratosDentroDosGrupos = (arr) => {
  arr.forEach((msc) => {
    delete msc.pratosDentroDosGrupos;
  });
  return arr;
};

let getWeekNumber = (dia) => {
  return moment(dia, 'DD/MM/YYYY').week();
};

this.generateDiaConfig = (dia, frequencias, prato_combinacao, sequencialCenarioOriginal) => {
  tentativasPorDia++;

  let configDiaTemp = Object.assign([], dia.pratos);
  let sequenciais = dia.sequenciaisOrdenados;

  let pPrincipais = [];
  let grupUsed = [];

  dia.tempING_USED = Object.assign([], dia.ING_USED || {});
  dia.tempMDPREP_USED = Object.assign([], dia.MDPREP_USED || []);
  dia.tempTPCORT_USED = Object.assign([], dia.TPCORT_USED || []);

  sequenciais = sequenciais.filter((seq) => {
    if (
      !configDiaTemp.find((cdt) => cdt.sequencial == seq) &&
      ((Array.isArray(sequencialCenarioOriginal) &&
        !sequencialCenarioOriginal.find((original) => original.NRSEQCNFCARD == seq)) ||
        !sequencialCenarioOriginal ||
        (Array.isArray(sequencialCenarioOriginal) && sequencialCenarioOriginal.length === 0))
    ) {
      return seq;
    }
  });
  for (let i = 0; i < sequenciais.length; i++) {
    const sequencial = sequenciais[i];

    dia.seq[sequencial] = dia.seq[sequencial].filter((dish) => {
      return MenuAnalytics.isValidDishOnDay(dia.dia, sequencial, dish);
    });

    let dadosCurSeq = dia.seqInfo.find((si) => sequencial == si.NUM_SEQUENCIA);
    let combinacoes = prato_combinacao.filter(
      (pc) =>
        pc.COD_GRP_TIP_PRATO_COMB == dadosCurSeq.COD_GRP_TIP_PRATO &&
        pPrincipais.find((p) => p.COD_GRP_TIP_PRATO == pc.COD_GRP_TIP_PRATO && pc.COD_PRATO == p.COD_PRATO),
    );

    let pratos = dia.seq[sequencial].filter((pr) => !grupUsed.includes(pr.gpprato));
    if (pratos.length == 0) {
      pratos = dia.seq[sequencial];
    }

    let pratosCombinantes = Object.assign([], pratos);
    pratosCombinantes = pratosCombinantes.filter((pr) => {
      let comb = combinacoes.find((c) => c.COD_PRATO_COMB == pr.prato || pr.gpprato == c.NRGRUPOPRATOSERV_COMB);
      if (comb) {
        let esqPr = comb.COD_PRATO;
        let esqGp = comb.NRGRUPOPRATOSERV;
        const leftComb = configDiaTemp.find((p) => p.prato == esqPr || p.gpprato == esqGp)
        pr.pratoOrigin = leftComb ? (pr.pratOrigin = leftComb.prato) : null;
        if (pr.pratoOrigin) pr.utilizacao = 'O';
        return pr;
      }
    });

    pratos = pratosCombinantes.length > 0 ? pratosCombinantes : pratos;

    let gruposSequencial = dia.seqInfo.find((si) => si.NUM_SEQUENCIA == sequencial).NUM_GRP_PRATO;
    let weekNumber = getWeekNumber(dia.dia);
    let filtredDishes = MenuAnalytics.filterPreferenceDishesOnDay(dia.dia, sequencial, pratos);
    let prato = getPratoFromPlateListWithFreq( filtredDishes, frequencias, weekNumber, gruposSequencial, dia.tempING_USED, dia, false) 
      || getPratoFromPlateListWithFreq( pratos, frequencias, weekNumber, gruposSequencial, dia.tempING_USED, dia, false);
    if (!prato || !prato.prato) {
      filtredDishes = MenuAnalytics.filterPreferenceDishesOnDay(dia.dia, sequencial, dia.seq[sequencial]);
      prato = getPratoFromPlateListWithFreq(
        filtredDishes,
        frequencias,
        weekNumber,
        gruposSequencial,
        dia.tempING_USED,
        dia,
        false,
      );
      prato = prato || getPratoFromPlateListWithFreq(
        dia.seq[sequencial],
        frequencias,
        weekNumber,
        gruposSequencial,
        dia.tempING_USED,
        dia,
        false,
      );
    }

    if (!prato || !prato.prato) {
      prato = getPratoFromPlateListWithNoFreq(filtredDishes, frequencias, dia.tempING_USED);
      prato = prato || getPratoFromPlateListWithNoFreq(dia.seq[sequencial], frequencias, dia.tempING_USED);
    }

    if (!prato || !prato.prato) {
      const dishes = dia.ptrsOriginal[sequencial].filter((dish) =>
        MenuAnalytics.isValidDishOnDay(dia.dia, sequencial, dish)
      && MenuAnalytics.isValidDishInConsecutiveDays(dia.dia, sequencial, dish),
      );
      prato = getPratoFromPlateListWithFreq(
        MenuAnalytics.filterPreferenceDishesOnDay(dia.dia, sequencial, dishes),
        frequencias,
        weekNumber,
        gruposSequencial,
        dia.tempING_USED,
        dia,
        false,
      );
      prato = prato || getPratoFromPlateListWithFreq(
        dishes,
        frequencias,
        weekNumber,
        gruposSequencial,
        dia.tempING_USED,
        dia,
        false,
      );
    }

    if (prato && prato.prato) {
      grupUsed.push(prato.gpprato);
      MenuAnalytics.analyze(dia.dia, sequencial, prato);
      Frequency.addFrequencyOnMenu(frequencias, prato, weekNumber);
      let currentDay = parseInt(dia.dia.substring(0, 2));
      ING_USED = updateIngUsed(prato, dia.tempING_USED, currentDay);

      if (prato.MODO_PREPARO && dia.tempMDPREP_USED.indexOf(prato.MODO_PREPARO) == -1) {
        dia.tempMDPREP_USED.push(prato.MODO_PREPARO);
      }

      if (prato.TP_CORTE && dia.tempTPCORT_USED.indexOf(prato.TP_CORTE) == -1) {
        dia.tempTPCORT_USED.push(prato.TP_CORTE);
      }

      let pccomb = prato_combinacao.find(
        (pc) =>
          (prato.prato == pc.COD_PRATO || prato.gpprato == pc.NRGRUPOPRATOSERV) &&
          pc.COD_GRP_TIP_PRATO == dadosCurSeq.COD_GRP_TIP_PRATO,
      );
      if (pccomb) {
        pPrincipais.push(pccomb);
      }

      dia = removeRestrictions(dia, prato, this.res_prato_combinacao);

      configDiaTemp.push(prato);
    }
  }

  return configDiaTemp;
};

this.validaMetaECor = (seqInfo, percCor, configDia, meta, conjuntoPorcao, prato_combinacao) => {
  let mediaCusto = 0;
  let custoTotal = 0;
  let mediaCor = {};
  let mediaCorGPTPPT = {};
  // let corMenorQueMedia = true;
  // let corGPTPPTMenorQueMedia = true;

  let pesosAcum = {};
  let histAcum = {};

  configDia.forEach((prato) => {
    let atrSeq = seqInfo.find((si) => si.NUM_SEQUENCIA == prato.sequencial && si.ATRATIVIDADE == 'ATRATIVIDADE');
    if (atrSeq && prato.VRPESOATRATIVIDADE) {
      pesosAcum[atrSeq.COD_GRP_TIP_PRATO] = pesosAcum[atrSeq.COD_GRP_TIP_PRATO]
        ? (pesosAcum[atrSeq.COD_GRP_TIP_PRATO] += parseInt(prato.VRPESOATRATIVIDADE))
        : parseInt(prato.VRPESOATRATIVIDADE);
    } else {
      atrSeq = seqInfo.find((si) => si.NUM_SEQUENCIA == prato.sequencial);
      if (atrSeq) {
        histAcum[atrSeq.COD_GRP_TIP_PRATO] = histAcum[atrSeq.COD_GRP_TIP_PRATO]
          ? histAcum[atrSeq.COD_GRP_TIP_PRATO] + parseFloat(prato.percentualConsumo)
          : parseFloat(prato.percentualConsumo);
      }
    }
  });

  configDia.forEach((prato) => {
    let pesPrato = pesosAcum[prato.COD_GRP_TIP_PRATO];
    let isATV = seqInfo.find(
      (si) =>
        si.NUM_SEQUENCIA == prato.sequencial && prato.VRPESOATRATIVIDADE != null && si.ATRATIVIDADE == 'ATRATIVIDADE',
    );
    if (pesPrato && prato.VRPESOATRATIVIDADE && isATV != null) {
      let percAT = conjuntoPorcao.find((cp) => cp.CDGRTIPOPR == prato.COD_GRP_TIP_PRATO);
      let percHist = histAcum[prato.COD_GRP_TIP_PRATO] || 0;
      if (percAT) {
        if (percAT.VRCONJUNTOPORCAO > percHist) {
          percAT = percAT.VRCONJUNTOPORCAO - percHist;
        } else {
          percAT = percAT.VRCONJUNTOPORCAO;
        }
      } else {
        percAT = 100;
      }

      prato.percentualConsumo = (prato.VRPESOATRATIVIDADE / pesPrato) * percAT;
    }

    let isCombReduced = prato_combinacao.find(
      (pc) =>
        ((pc.COD_GRP_TIP_PRATO_COMB == prato.COD_GRP_TIP_PRATO && !pc.NRGRUPOPRATOSERV_COMB && !pc.COD_PRATO_COMB) ||
          pc.NRGRUPOPRATOSERV_COMB == prato.gpprato ||
          pc.COD_PRATO_COMB == prato.prato) &&
        configDia.find((cd) => pc.COD_PRATO == cd.prato || pc.NRGRUPOPRATOSERV == cd.gpprato),
    );
    if (isCombReduced && isCombReduced.PERCENTREDUCAO && isCombReduced.PERCENTREDUCAO != 0) {
      prato.percentualConsumo =
        parseFloat(prato.percentualConsumo) -
        (parseFloat(prato.percentualConsumo) * parseFloat(isCombReduced.PERCENTREDUCAO)) / 100;
    }
  });

  configDia.forEach((prato) => {
    if (prato.COR_PRATO) {
      mediaCor[prato.COR_PRATO] = mediaCor[prato.COR_PRATO] ? mediaCor[prato.COR_PRATO] + 1 : 1;
      if (!mediaCorGPTPPT[prato.COD_GRP_TIP_PRATO]) {
        mediaCorGPTPPT[prato.COD_GRP_TIP_PRATO] = {};
      }
      mediaCorGPTPPT[prato.COD_GRP_TIP_PRATO][prato.COR_PRATO] = mediaCorGPTPPT[prato.COD_GRP_TIP_PRATO][
        prato.COR_PRATO
      ]
        ? mediaCorGPTPPT[prato.COD_GRP_TIP_PRATO][prato.COR_PRATO] + 1
        : 1;
    }
    mediaCusto = mediaCusto + parseFloat(prato.VLR_CUSTO_PRATO) * (parseFloat(prato.percentualConsumo) / 100);
    custoTotal = custoTotal + parseFloat(prato.VLR_CUSTO_PRATO);
  });
  /*
  for (const cor in mediaCor) {
      if (mediaCor.hasOwnProperty(cor)) {
          const nCor = mediaCor[cor];
          if (nCor > 1 && (nCor / configDia.length) > percCor) {
              corMenorQueMedia = false;
          }
      }
  }

  for (const gptppt in mediaCorGPTPPT) {
      if (mediaCorGPTPPT.hasOwnProperty(gptppt)) {
          const corGPTPPT = mediaCorGPTPPT[gptppt];

          for (const cor in corGPTPPT) {
              if (corGPTPPT.hasOwnProperty(cor)) {
                  const nCor = corGPTPPT[cor];
                  if (nCor > 1 && (nCor / configDia.filter(cd => cd.COD_GRP_TIP_PRATO == gptppt)).length > percCor) {
                      corGPTPPTMenorQueMedia = false;
                  }
              }
          }
      }
  }
  */
  configDia.mediaCusto = mediaCusto;
  configDia.custoTotal = custoTotal;
  let metaCorrente = meta.cur || meta.VRL_CUSTO_MAX;
  let obedeceAMeta = mediaCusto >= meta.VLR_CUSTO_MIN && mediaCusto <= metaCorrente;
  return obedeceAMeta /*&& corMenorQueMedia && corGPTPPTMenorQueMedia*/;
};

this.validatePlateCombination = (configDia, prato_combinacao) => {
  let foundCombination = true;
  configDia.forEach((plate) => {
    let requirements = prato_combinacao.filter((combination) => {
      return plate.prato === combination.COD_PRATO && plate.COD_GRP_TIP_PRATO === combination.COD_GRP_TIP_PRATO;
    });
    if (requirements.length > 0) {
      requirements.forEach((requirement) => {
        let found = configDia.find((_tpplate) => _tpplate.COD_GRP_TIP_PRATO === requirement.COD_GRP_TIP_PRATO_COMB);
        if (found) {
          if (configDia.filter((_plate) => _plate.prato === requirement.COD_PRATO_COMB).length === 0) {
            foundCombination = false;
          }
        }
      });
    }
  });
  return foundCombination;
};

this.validateConfig = (
  cor,
  dia,
  meta,
  prato_combinacao,
  res_prato_combinacao,
  complexidade,
  frequencias,
  conjuntoPorcao,
  sequencialCenarioOriginal,
) => {
  let configDia;
  let bkpIngUsed = new Map(this.ingUsed);
  do {
    configDia = this._validateConfig(
      cor,
      dia,
      meta,
      prato_combinacao,
      res_prato_combinacao,
      complexidade,
      frequencias,
      conjuntoPorcao,
      sequencialCenarioOriginal,
    );
    if (!configDia) this.ingUsed = new Map(bkpIngUsed);
  } while (!configDia);

  return configDia;
};

this.validateResPlateCombinationComplexidade = (configDia, res_prato_combinacao, complexidade) => {
  let tpComplexidade = {};
  let complexidadeMenorQMAX = true;

  let isConfigValid = true;

  configDia.forEach((prato) => {
    if (prato.COMPLEX_PRATO) {
      if (!tpComplexidade[prato.COD_GRP_TIP_PRATO]) {
        tpComplexidade[prato.COD_GRP_TIP_PRATO] = {};
      }
      tpComplexidade[prato.COD_GRP_TIP_PRATO][prato.COMPLEX_PRATO] = tpComplexidade[prato.COD_GRP_TIP_PRATO][
        prato.COMPLEX_PRATO
      ]
        ? tpComplexidade[prato.COD_GRP_TIP_PRATO][prato.COMPLEX_PRATO] + 1
        : 1;
    }

    let restrictions = res_prato_combinacao.filter((combination) => {
      return prato.prato === combination.COD_PRATO && prato.COD_GRP_TIP_PRATO === combination.COD_GRP_TIP_PRATO;
    });
    if (restrictions.length > 0) {
      restrictions.forEach((restriction) => {
        let found = configDia.find(
          (_prato) =>
            _prato.prato === restriction.COD_PRATO_COMB &&
            _prato.COD_GRP_TIP_PRATO === restriction.COD_GRP_TIP_PRATO_COMB,
        );
        if (found) {
          isConfigValid = false;
        }
      });
    }
  });
  if (isConfigValid) {
    for (const comple in tpComplexidade) {
      if (tpComplexidade.hasOwnProperty(comple)) {
        const curComple = tpComplexidade[comple];

        let complexOfCurDay = complexidade.find((comp) => comp.COD_GRP_TIP_PRATO == comple);
        if (complexOfCurDay) {
          for (const comp in curComple) {
            if (curComple.hasOwnProperty(comp)) {
              const qtComp = curComple[comp];
              if (complexidadeMenorQMAX && complexOfCurDay['QTD_' + comp]) {
                complexidadeMenorQMAX = qtComp <= complexOfCurDay['QTD_' + comp];
              }
              if (!complexidadeMenorQMAX) {
                tpComplexidade = {};
                return complexidadeMenorQMAX;
              }
            }
          }
        }
      }
    }
  }
  return isConfigValid && complexidadeMenorQMAX;
};

this._validateConfig = (
  cor,
  dia,
  meta,
  prato_combinacao,
  res_prato_combinacao,
  complexidade,
  frequencias,
  conjuntoPorcao,
  sequencialCenarioOriginal,
) => {
  let qtSeq = Object.keys(dia.seq).length;
  let configDia = this.generateDiaConfig(dia, frequencias, prato_combinacao, sequencialCenarioOriginal);
  configDia.status = {
    validaMetaECor: this.validaMetaECor(dia.seqInfo, cor, configDia, meta, conjuntoPorcao, prato_combinacao),
    validateResPlateCombinationComplexidade: this.validateResPlateCombinationComplexidade(
      configDia,
      res_prato_combinacao,
      complexidade,
    ),
    isComplete: qtSeq == configDia.length,
  };

  if (configDia.length != qtSeq) {
    if (!this.melhorPiorCombinação[dia.dia + 'i']) {
      this.melhorPiorCombinação[dia.dia + 'i'] = {};
      this.melhorPiorCombinação[dia.dia + 'i'] = Object.assign({}, configDia);
    } else if (
      this.melhorPiorCombinação[dia.dia + 'i'].mediaCusto > configDia.mediaCusto &&
      configDia.length >= this.melhorPiorCombinação[dia.dia + 'i'].length
    ) {
      this.melhorPiorCombinação[dia.dia + 'i'] = Object.assign({}, configDia);
    }
  } else {
    if (!this.melhorPiorCombinação[dia.dia]) {
      this.melhorPiorCombinação[dia.dia] = {};
      this.melhorPiorCombinação[dia.dia] = Object.assign({}, configDia);
    } else if (this.melhorPiorCombinação[dia.dia].mediaCusto > configDia.mediaCusto) {
      this.melhorPiorCombinação[dia.dia] = Object.assign({}, configDia);
    }
  }

  let allButMetaIsValid = configDia.status.validateResPlateCombinationComplexidade && configDia.status.isComplete;

  if ((configDia.status.validaMetaECor && allButMetaIsValid) || tentativasPorDia > this.numMaxTent) {
    if (tentativasPorDia > this.numMaxTent) {
      if (!!this.melhorPiorCombinação[dia.dia]) {
        if (this.melhorPiorCombinação[dia.dia].mediaCusto < configDia.mediaCusto) {
          configDia = Object.assign([], this.melhorPiorCombinação[dia.dia]);
        }
      } else if (!!this.melhorPiorCombinação[dia.dia + 'i'] && configDia.status.isComplete == false) {
        if (this.melhorPiorCombinação[dia.dia + 'i'].mediaCusto < configDia.mediaCusto) {
          configDia = Object.assign([], this.melhorPiorCombinação[dia.dia + 'i']);
        }
      }
    }

    dia.ING_USED = dia.tempING_USED || [];
    dia.MDPREP_USED = dia.tempMDPREP_USED || [];
    dia.TPCORT_USED = dia.tempTPCORT_USED || [];

    delete dia.tempING_USED;
    delete dia.tempMDPREP_USED;
    delete dia.tempTPCORT_USED;

    return configDia;
  } else {
    return null;
  }
};

this.priorizaGruposPoucoUtilizados = (grupoA, grupoB) => {
  let utilizacaoA = grupoA.cur || 0;
  let utilizacaoB = grupoB.cur || 0;
  if (grupoA.MIN_MES_GRP && grupoB.MIN_MES_GRP) {
    let atingiuMinimoA = utilizacaoA >= grupoA.MIN_MES_GRP;
    let atingiuMinimoB = utilizacaoB >= grupoB.MIN_MES_GRP;
    if (!atingiuMinimoA && atingiuMinimoB) {
      return -1;
    } else if (!atingiuMinimoA && !atingiuMinimoB) {
      let restanteA = 1 - utilizacaoA / Number(grupoA.MIN_MES_GRP);
      let restanteB = 1 - utilizacaoB / Number(grupoB.MIN_MES_GRP);
      if (restanteA > restanteB) return -1;
      return 1;
    } else if (!atingiuMinimoB) {
      return 1;
    } else {
      return -1;
    }
  } else if (grupoA.MIN_MES_GRP) {
    return -1;
  } else if (grupoB.MIN_MES_GRP) {
    return 1;
  } else {
    return -1;
  }
};

let getPratoFromPlateListWithFreq = (
  pratos,
  frequencias,
  weekNumber,
  gruposSequencial,
  ING_USED,
  dia,
  preCard = true,
) => {
  let pratosUnicos = Object.assign([], pratos);
  let choPrato = null;
  let currentDay = parseInt(dia.dia.substring(0, 2), 10);
  let filtredFreq = frequencias.filter((fr) => {
    if (fr.NUM_GRP_PRATO && !fr.COD_PRODUTO && gruposSequencial.includes(fr.NUM_GRP_PRATO)) {
      if (fr.cur) {
        let notMaxSemana =
          fr.curWeekUsage &&
          (!fr.curWeekUsage[weekNumber] ||
            (fr.curWeekUsage[weekNumber] && fr.curWeekUsage[weekNumber] < fr.MAX_SEM_GRP));
        if (fr.cur < fr.MIN_MES_GRP && notMaxSemana) {
          return fr;
        }
      } else {
        return fr;
      }
    }
  });

  let filtredPratosUnicos = Object.assign([], pratosUnicos);
  if (filtredFreq.length) {
    filtredPratosUnicos = pratosUnicos.filter((pu) => {
      if (filtredFreq.find((ff) => ff.NUM_GRP_PRATO == pu.gpprato)) {
        return pu;
      }
    });
  }

  if (filtredPratosUnicos.length == 0) {
    filtredPratosUnicos = Object.assign([], pratosUnicos);
  }

  const hasIngredValidation = this.tipoPratoRestricaoIngrediente.includes(
    filtredPratosUnicos[0] && filtredPratosUnicos[0].COD_TIP_PRATO,
  );

  if (hasIngredValidation) {
    filtredPratosUnicos = filtredPratosUnicos.filter((p) => {
      let rest = Object.entries(this.restIng).find((r) => r[0].split(',').includes(p.COD_TIP_PRATO));
      if (rest) {
        rest = rest[1];
        let rg1 = rest[p.INGR_PRINCIPAL_1] || rest['XX'] || null;
        let rg2 = rest[p.INGR_PRINCIPAL_2] || rest['XX'] || null;
        if (p.INGR_PRINCIPAL_1 === null) {
          rg1 = null;
        }
        if (p.INGR_PRINCIPAL_2 === null) {
          rg2 = null;
        }
        let isWithoutRule = (!rg1 || rg1.INGR_PRINCIPAL_1 == 'N') && (!rg2 || rg2.INGR_PRINCIPAL_2 == 'N');
        if (
          isWithoutRule ||
          !ING_USED['CP'] ||
          ((p.INGR_PRINCIPAL_1 ? !ING_USED['CP'].includes(p.INGR_PRINCIPAL_1) : true) &&
            (p.INGR_PRINCIPAL_2 ? !ING_USED['CP'].includes(p.INGR_PRINCIPAL_2) : true))
        ) {
          if (
            !isWithoutRule &&
            ((rg1 && !isAllowedIngredient(currentDay, p.INGR_PRINCIPAL_1, rg1.IDDIASEGUIDO)) ||
              (rg2 && !isAllowedIngredient(currentDay, p.INGR_PRINCIPAL_2, rg2.IDDIASEGUIDO)))
          ) {
            // possui regra de ingrediente e o ingrediente atual não é permitido
            return false;
          }
          return p;
        }
      } else if (
        !ING_USED ||
        !ING_USED['OTHERS'] ||
        (!ING_USED['OTHERS'].includes(p.INGR_PRINCIPAL_1) && !ING_USED['OTHERS'].includes(p.INGR_PRINCIPAL_2))
      ) {
        return p;
      }
    });
  }

  const uniqueGroups = new Set();
  filtredPratosUnicos.forEach((dish) => uniqueGroups.add(dish.gpprato));
  let filtredGroups = [...uniqueGroups];
  // POR ORDEM DE FREQUENCIAS
  const hasGroupWithFreq = filtredGroups.some((g) => frequencias.some((f) => f.MIN_MES_GRP && f.NUM_GRP_PRATO == g));
  if (hasGroupWithFreq) {
    const frequencyByGroup = {};
    frequencias.forEach(freq => {
      if(freq.MIN_MES_GRP && freq.NUM_GRP_PRATO) {
        frequencyByGroup[freq.NUM_GRP_PRATO] = freq;
      }
    });
    filtredGroups.sort(
      function (a, b) {
        let freqA = frequencyByGroup[a];
        let freqB = frequencyByGroup[b];
        return this.priorizaGruposPoucoUtilizados(freqA, freqB);
      }.bind(this),
    );
  } else {
    filtredGroups = shuffleArray(filtredGroups);
  }

  for (let i = 0; i < filtredGroups.length && !choPrato; i++) {
    let curGp = filtredGroups[i];
    let curGpPlates = Object.assign(
      [],
      filtredPratosUnicos.filter((fpu) => fpu.gpprato == curGp),
    );
    let curPlates = [];
    curGpPlates.forEach((pl) => {
      let freqPrato = frequencias.filter((fr) => fr.COD_PRATO && pl.prato == fr.COD_PRATO);
      let possuiFreqValida =
        !freqPrato.length ||
        freqPrato.find(
          (fr) =>
            !fr.cur ||
            (fr.cur &&
              fr.cur < fr.MAX_MES_PRATO &&
              (!fr.curWeekUsage[weekNumber] || fr.curWeekUsage[weekNumber] < fr.MAX_SEMANA)),
        );
      if (
        !this.prato_combinacao.find((pc) => pc.COD_PRATO_COMB == pl.prato || pc.NRGRUPOPRATOSERV_COMB == pl.gpprato) &&
        possuiFreqValida
      ) {
        curPlates.push(pl);
      }
    });
    if (curPlates.length == 0) {
      curPlates = curGpPlates;
    }

    do {
      let maxGroupUsageLimitReached = false;
      let pratoUnico = getRandonPlate(curPlates);
      if (pratoUnico) {
        let freqGr = frequencias.find((fr) => fr.NUM_GRP_PRATO == pratoUnico.gpprato && !fr.COD_PRODUTO);
        if (freqGr) {
          if (
            (freqGr.cur && freqGr.MAX_MES_GRP <= freqGr.cur) ||
            (freqGr.curWeekUsage &&
              freqGr.curWeekUsage[weekNumber] &&
              freqGr.MAX_SEM_GRP <= freqGr.curWeekUsage[weekNumber])
          ) {
            choPrato = null;
            maxGroupUsageLimitReached = true;
          } else {
            choPrato = pratoUnico;
          }
        }

        let freqPTD = frequencias.find(
          (fr) =>
            fr.NRGRUPOPRATOSERV == pratoUnico.gpprato &&
            fr.COD_PRODUTO &&
            pratoUnico.prods.find((pdts) => pdts.COD_PRODUTO == fr.COD_PRODUTO),
        );
        if (freqPTD) {
          if (
            (freqPTD.cur && freqPTD.MAX_MES_PRD <= freqPTD.cur) ||
            (freqPTD.curWeekUsage &&
              freqPTD.curWeekUsage[weekNumber] &&
              freqPTD.MAX_SEMANA <= freqPTD.curWeekUsage[weekNumber])
          ) {
            choPrato = null;
          } else if (!maxGroupUsageLimitReached) {
            choPrato = pratoUnico;
          }
        }

        let freqPr = frequencias.find((fr) => fr.COD_PRATO == pratoUnico.prato);
        if (freqPr) {
          if (
            (freqPr.cur && freqPr.MAX_MES_PRATO <= freqPr.cur) ||
            (freqPr.curWeekUsage &&
              freqPr.curWeekUsage[weekNumber] &&
              freqPr.MAX_SEM_GRP <= freqPr.curWeekUsage[weekNumber])
          ) {
            choPrato = null;
          } else if (!maxGroupUsageLimitReached) {
            choPrato = pratoUnico;
          }
        } else if (!freqPTD && !freqPr && !freqGr) {
          if (pratoUnico.utilizacao == 'O' || preCard == false) {
            choPrato = pratoUnico;
          }
        }

        if (!choPrato) {
          curPlates = curPlates.filter((pu) => {
            return pratoUnico && pu.prato != pratoUnico.prato;
          });
        }
      }
    } while (!choPrato && curPlates.length > 0);
  }
  return choPrato;
};

let getPratoFromPlateListWithNoFreq = (pratos, frequencias, ING_USED) => {
  let pratosWithNofreq = pratos.filter(
    (p) =>
      !frequencias.find(
        (f) =>
          f.NUM_GRP_PRATO &&
          f.NUM_GRP_PRATO ==
            p.gpprato /* && (f.cur && (f.cur < f.MAX_MES_GRP) && ((!f.curWeekUsage || !f.curWeekUsage[weekNumber] || f.curWeekUsage[weekNumber] < f.MAX_SEM_GRP))) */,
      ),
  );
  let isCP = this.tipoPratoRestricaoIngrediente.includes(pratosWithNofreq[0] && pratosWithNofreq[0].COD_TIP_PRATO);

  let respAtributos = pratosWithNofreq.filter((p) => {
    let rest = Object.entries(this.restIng).find((r) => r[0].split(',').includes(p.COD_TIP_PRATO));
    if (rest) {
      rest = rest[1];
      let rg1 = rest[p.INGR_PRINCIPAL_1] || rest['XX'] || null;
      let rg2 = rest[p.INGR_PRINCIPAL_2] || rest['XX'] || null;
      if (p.INGR_PRINCIPAL_1 === null) {
        rg1 = null;
      }
      if (p.INGR_PRINCIPAL_2 === null) {
        rg2 = null;
      }
      if (
        !ING_USED['CP'] ||
        (!ING_USED['CP'].includes(p.INGR_PRINCIPAL_1) && !ING_USED['CP'].includes(p.INGR_PRINCIPAL_2)) ||
        ((!rg1 || rg1.INGR_PRINCIPAL_1 == 'N') && (!rg2 || rg2.INGR_PRINCIPAL_2 == 'N'))
      ) {
        return p;
      }
    } else if (
      !ING_USED['OTHERS'] ||
      (!ING_USED['OTHERS'].includes(p.INGR_PRINCIPAL_1) && !ING_USED['OTHERS'].includes(p.INGR_PRINCIPAL_2))
    ) {
      return p;
    }
  });

  if (isCP) {
    pratosWithNofreq = respAtributos;
  } else {
    pratosWithNofreq = respAtributos.length == 0 ? pratosWithNofreq : respAtributos;
  }

  return getRandonPlate(pratosWithNofreq);
};

this.orderSeqIfPO = (seqWithPO, sequenciais, sequenciaisOrdenados) => {
  if (seqWithPO.length > 0) {
    let arr = [];
    let seqs = [];
    seqWithPO.forEach((s) => {
      let seq = s[0];
      seqs.push(sequenciais.splice(sequenciais.indexOf(seq), 1)[0]);
    });
    return arr.concat([], seqs, sequenciais);
  } else {
    return Object.assign([], sequenciaisOrdenados);
  }
};

this.orderSeqIfPPCOMB = (seqWithPC, seqWithPCOMB, sequenciaisOrdenados) => {
  let esquerda = seqWithPC.map((s) => s[0]);
  let centro = seqWithPCOMB.map((s) => s[0]);
  let total = [].concat(esquerda);

  centro.forEach((c) => {
    if (!total.includes(c)) {
      total.push(c);
    }
  });

  sequenciaisOrdenados.forEach((c) => {
    if (!total.includes(c)) {
      total.push(c);
    }
  });

  return total;
};

let removeRestrictions = function (dia, prato, res_prato_combinacao) {
  let rest = res_prato_combinacao.filter(
    (rpc) =>
      (rpc.COD_GRP_TIP_PRATO == prato.COD_GRP_TIP_PRATO &&
        (rpc.COD_PRATO == prato.prato || rpc.NRGRUPOPRATOSERV == prato.gpprato)) ||
      (rpc.COD_GRP_TIP_PRATO_COMB == prato.COD_GRP_TIP_PRATO &&
        (rpc.COD_PRATO_COMB == prato.prato || rpc.NRGRUPOPRATOSERV_COMB == prato.gpprato)),
  );
  if (rest.length > 0) {
    rest.forEach((rt) => {
      let concatSeq = rt.SEQ.split(';');
      concatSeq.pop();
      concatSeq.forEach((ps) => {
        let originalLength = dia.seq[ps].length;
        if (rt.CDTIPOPRAT) {
          dia.seq[ps] = dia.seq[ps].filter((dsp) => rt.CDTIPOPRAT != dsp.COD_TIP_PRATO);
          if (dia.seq[ps].length == 0) {
            dia.ptrsOriginal[ps] = [];
            if (originalLength !== 0) {
              dia.buracoObrigatorio = dia.buracoObrigatorio || new Set();
              dia.buracoObrigatorio.add(ps.toString());
            }
          }
        } else {
          dia.seq[ps] = dia.seq[ps].filter(
            (dsp) => rt.NRGRUPOPRATOSERV_COMB != dsp.gpprato && rt.NRGRUPOPRATOSERV != dsp.gpprato,
          );
          dia.seq[ps] = dia.seq[ps].filter((dsp) => rt.COD_PRATO_COMB != dsp.prato && rt.COD_PRATO != dsp.prato);
          if (dia.seq[ps].length == 0) {
            dia.ptrsOriginal[ps] = [];
            if (originalLength !== 0) {
              dia.buracoObrigatorio = dia.buracoObrigatorio || new Set();
              dia.buracoObrigatorio.add(ps.toString());
            }
          }
        }
      });
    });
  }
  return dia;
};

let listLastWeekSameDay = (dia, diasSemanaCardOrd) => {
  let curIndex = diasSemanaCardOrd.findIndex((d) => d.dia == dia.dia);
  let lastDay = diasSemanaCardOrd[curIndex - 1] ? diasSemanaCardOrd[curIndex - 1].pratos || [] : [];
  let nextDay = diasSemanaCardOrd[curIndex + 1] ? diasSemanaCardOrd[curIndex + 1].pratos || [] : [];

  return [].concat(lastDay, nextDay);
};

let fillIngUsed = (day, ing) => {
  if (day && ing) {
    if (this.ingUsed.has(day)) {
      this.ingUsed.get(day).add(ing);
    } else {
      this.ingUsed.set(day, new Set([ing]));
    }
  }
};

let hasIngYesterdayOrTomorrow = (today, ing) => {
  if (this.ingUsed.has(today - 1) && this.ingUsed.get(today - 1).has(ing)) {
    return true;
  } else if (this.ingUsed.has(today + 1) && this.ingUsed.get(today + 1).has(ing)) {
    return true;
  }
  return false;
};

let isAllowedIngredient = (today, ing, restrictConsecutiveDay) => {
  if (this.ingUsed.has(today) && this.ingUsed.get(today).has(ing)) {
    return false;
  }
  if (restrictConsecutiveDay == 'S') {
    return !hasIngYesterdayOrTomorrow(today, ing);
  }
  return true;
};

let updateIngUsed = (prato, ING_USED, currentDay) => {
  if (this.tipoPratoRestricaoIngrediente.includes(prato.COD_TIP_PRATO)) {
    ING_USED['CP'] = ING_USED['CP'] || [];
    if (!ING_USED['CP'].includes(prato.INGR_PRINCIPAL_1)) {
      ING_USED['CP'].push(prato.INGR_PRINCIPAL_1);
      fillIngUsed(currentDay, prato.INGR_PRINCIPAL_1);
    }

    if (!ING_USED['CP'].includes(prato.INGR_PRINCIPAL_2)) {
      ING_USED['CP'].push(prato.INGR_PRINCIPAL_2);
      fillIngUsed(currentDay, prato.INGR_PRINCIPAL_2);
    }
  } else {
    ING_USED['OTHERS'] = ING_USED['OTHERS'] || [];
    if (prato.INGR_PRINCIPAL_1 && ING_USED['OTHERS'].indexOf(prato.INGR_PRINCIPAL_1) == -1) {
      ING_USED['OTHERS'].push(prato.INGR_PRINCIPAL_1);
    }

    if (prato.INGR_PRINCIPAL_2 && ING_USED['OTHERS'].indexOf(prato.INGR_PRINCIPAL_2) == -1) {
      ING_USED['OTHERS'].push(prato.INGR_PRINCIPAL_2);
    }
  }
  return ING_USED;
};

let removePlatesRestriLastweek = (dia, platesRestriLastweek, sequencial, frequencias) => {
  platesRestriLastweek = platesRestriLastweek.filter((p) => p.utilizacao != 'O');
  let seqPlates = platesRestriLastweek.filter((p) => p.sequencial == sequencial);
  let withoutSamePlate = dia.seq[sequencial].filter((p) => !seqPlates.find((sp) => sp.prato == p.prato));
  dia.seq[sequencial] = withoutSamePlate.length > 0 ? withoutSamePlate : dia.seq[sequencial];

  seqPlates.forEach((p) => {
    let newListPlateWithNoRed = dia.seq[sequencial].filter((dp) => dp.prato != p.prato || dp.gpprato != p.gpprato);
    let newListPlateWithNoRedGrups = dia.seq[sequencial].filter((dp) => dp.gpprato != p.gpprato);
    let newListPlateWithNoRedPlate = dia.seq[sequencial].filter((dp) => dp.prato != p.prato);
    let newPlateList = [];

    if (newListPlateWithNoRed.length != 0) {
      newPlateList = newListPlateWithNoRed;
    } else {
      if (newListPlateWithNoRedGrups.length != 0) {
        newPlateList = newListPlateWithNoRedGrups;
      } else {
        if (newListPlateWithNoRedPlate.length != 0) {
          newPlateList = newListPlateWithNoRedPlate;
        }
      }
    }

    newPlateList = checkFreqListComparation(newPlateList, dia.seq[sequencial], frequencias, dia);
    dia.seq[sequencial] = newPlateList;
  });

  if (dia.seq[sequencial].length > 1) {
    let plateDia = dia.seq[sequencial].filter(
      (p) =>
        !platesRestriLastweek.find(
          (prlw) =>
            prlw.sequencial == sequencial &&
            p.sequencial == sequencial &&
            (prlw.gpprato == p.gpprato || prlw.prato == p.prato),
        ),
    );
    if (plateDia.length > 0) {
      dia.seq[sequencial] = plateDia;
    } else {
      plateDia = dia.seq[sequencial].filter(
        (p) =>
          !platesRestriLastweek.find(
            (prlw) => prlw.sequencial == sequencial && p.sequencial == sequencial && prlw.prato == p.prato,
          ),
      );
    }
    if (plateDia.length != 0) {
      dia.seq[sequencial] = checkFreqListComparation(plateDia, dia.seq[sequencial], frequencias, dia);
    }
  }

  return dia.seq[sequencial];
};

function isCombByGroupDishType(dishComb, dish) {
  return (
    dishComb.COD_GRP_TIP_PRATO_COMB == dish.COD_GRP_TIP_PRATO &&
    !dishComb.NRGRUPOPRATOSERV_COMB &&
    !dishComb.COD_PRATO_COMB
  );
}

function isCombByGroup(dishComb, dish) {
  return dishComb.NRGRUPOPRATOSERV_COMB == dish.gpprato;
}

function isCombByDish(dishComb, dish) {
  return dishComb.COD_PRATO_COMB == dish.prato;
}

function getLeftCombOnDay(dishComb, menuDay) {
  return menuDay.find((cd) => dishComb.COD_PRATO == cd.prato || dishComb.NRGRUPOPRATOSERV == cd.gpprato);
}

this.generatePreCard = (
  utilizacaoPratoSemana,
  cardapio,
  frequencias,
  prato_combinacao,
  calendario,
  res_prato_combinacao,
  lastWeekProds,
) => {
  let log = {};
  log.precardData = {};
  cardapio.seqInfo = removePratosDentroDosGrupos(cardapio.seqInfo);
  let diasOrdemSemana = generateDowShuffled(utilizacaoPratoSemana);
  let sequenciais = Object.keys(cardapio.datas[0].seq);

  let sequenciaisOrdenados = [...sequenciais];
  sequenciais = Object.assign([], sequenciaisOrdenados);
  let preCardOrder = ['obg', 'comb', 'obg'];

  for (let i = 0; i < preCardOrder.length; i++) {
    let cardOrd = preCardOrder[i];
    for (let i = 0; i < diasOrdemSemana.length; i++) {
      const curDia = diasOrdemSemana[i];
      let diasSemanaCard = cardapio.datas.filter((d) => d.nDiasemana == curDia);
      if (lastWeekProds && diasSemanaCard.length > 0) {
        let min = null;
        let indexOfMin = -1;
        diasSemanaCard.forEach((dos, index) => {
          let diaComp = moment(dos.dia, 'DD/MM/YYYY').format('YYYYMMDD');
          if (!min) {
            min = diaComp;
            indexOfMin = index;
          } else if (min > diaComp) {
            min = diaComp;
            indexOfMin = index;
          }
        });
        diasSemanaCard.unshift(diasSemanaCard.splice(indexOfMin, 1)[0]);
      }

      let diasSemanaCardOrd = Object.assign([], diasSemanaCard);
      diasSemanaCardOrd.sort((a, b) => {
        if (moment(a.dia, 'DD/MM/YYYY').format('YYYYMMDD') < moment(b.dia, 'DD/MM/YYYY').format('YYYYMMDD')) {
          return -1;
        }
        return 1;
      });

      diasSemanaCard.forEach((dia) => {
        let logPratos = [];
        dia.ptrsOriginal = dia.ptrsOriginal ? dia.ptrsOriginal : JSON.parse(JSON.stringify(dia.seq));
        dia.seqBKP = Object.assign({}, dia.seq);

        let weekNumber = moment(dia.dia, 'DD/MM/YYYY').week();

        if (cardOrd != 'obg') {
          const dishesToRemoveInfo = this.checkYesterdayAndTomorow(cardapio, dia, calendario, true);
          if (dishesToRemoveInfo.dishes.length) {
            dia = this.removeExcludedPlates(dia, dishesToRemoveInfo, frequencias, { only2: true });
            dia.seqBKP = Object.assign({}, dia.seq);
          }
        }

        let platesRestriLastweek = listLastWeekSameDay(dia, diasSemanaCardOrd);

        dia.sequenciaisOrdenados = Object.assign([], sequenciaisOrdenados);
        dia.seqInfo = cardapio.seqInfo;

        if (cardOrd == 'obg') {
          let seqWithRes = Object.entries(dia.seq).filter((ds) =>
            ds[1].find(
              (p) =>
                res_prato_combinacao.filter(
                  (rpc) =>
                    (rpc.COD_PRATO == p.prato || rpc.NRGRUPOPRATOSERV == p.gpprato) &&
                    rpc.COD_GRP_TIP_PRATO == p.COD_GRP_TIP_PRATO &&
                    rpc.CDTIPOPRAT == null,
                ).length != 0,
            ),
          );
          sequenciais = this.orderSeqIfPO(seqWithRes, sequenciais, sequenciaisOrdenados);
        } else if (cardOrd == 'comb') {
          let seqWithRes = Object.entries(dia.seq).filter((ds) =>
            ds[1].find(
              (p) =>
                prato_combinacao.filter((c) => c.COD_PRATO == p.prato || p.gpprato == c.NRGRUPOPRATOSERV).length != 0,
            ),
          );
          sequenciais = this.orderSeqIfPO(seqWithRes, sequenciais, sequenciaisOrdenados);
        }

        let pratosConfDia = dia.pratos || [];
        let pratUsSeq = dia.pratUsSeq || []; // Pratos usados no dia
        let grupUsed = dia.grupUsed || []; // Grupo de Pratos usados no dia

        let ING_USED = dia.ING_USED || {};
        let MDPREP_USED = dia.MDPREP_USED || [];
        let TPCORT_USED = dia.TPCORT_USED || [];
        let partialCombSeq = {};
        let seqsToFillEmpty = [];
        for (let i = 0; i < sequenciais.length; i++) {
          let sequencial = sequenciais[i];

          if (!pratosConfDia.find((p) => p.sequencial == sequencial)) {
            let hasRightAndLeftComb = false;
            dia.seq[sequencial] = removePlatesRestriLastweek(dia, platesRestriLastweek, sequencial, frequencias);

            let pratos = dia.seq[sequencial].filter(
              (pr) => !pratUsSeq.includes(pr.prato) && !grupUsed.includes(pr.gpprato),
            );
            if (pratos.length == 0) {
              pratos = dia.seq[sequencial].filter((pr) => !pratUsSeq.includes(pr.prato));
              grupUsed = [];
            }

            let pratosO = pratos.filter((p) => {
              let combLeft = null;
              let combRight = prato_combinacao.find((pc) => {
                let isComb = isCombByGroupDishType(pc, p) || isCombByGroup(pc, p) || isCombByDish(pc, p);
                let hasCombLeft = false;
                if (isComb) {
                  combLeft = getLeftCombOnDay(pc, pratosConfDia);
                  hasCombLeft = !!combLeft;
                }
                return isComb && hasCombLeft;
              });
              let isCombRight = !!combRight;
              let ptConfDia = (pratosConfDia || []).find(
                (cd) => isCombRight && (combRight.COD_PRATO == cd.prato || combRight.NRGRUPOPRATOSERV == cd.gpprato),
              );
              if (checkFreqListComparationBool([p], frequencias, dia) && isCombRight) {
                p.pratoOrigin = ptConfDia.prato;
                p.utilizacao = 'O';
                return p;
              }
            });

            if (pratosO.length == 0) {
              pratosO = pratos.filter((p) => p.utilizacao == 'O');
            } else {
              hasRightAndLeftComb = true;
            }

            let curPlateOrigin = [];

            if (pratosO.length == 0) {
              pratos.forEach((pCPO) => {
                let ut = utilizacaoPratoSemana.filter((u) => u.NUM_GRP_PRATO == pCPO.gpprato);
                let isObg = false;

                ut.forEach((u) => {
                  let keys = Object.keys(u).filter((key) => key.includes('IND_'));
                  for (let i = 0; i < keys.length; i++) {
                    if (u[keys[i]] == 'O') {
                      isObg = true;
                    }
                  }
                });
                if (!isObg) {
                  curPlateOrigin.push(pCPO);
                }
              });
              if (curPlateOrigin.length == 0) {
                curPlateOrigin = pratos;
              }
            } else {
              curPlateOrigin = pratosO;
            }

            let gruposSequencial = dia.seqInfo.find((si) => si.NUM_SEQUENCIA == sequencial).NUM_GRP_PRATO;
            let prato = null;
            if (cardOrd == 'obg') {
              curPlateOrigin = curPlateOrigin.filter((p) => p.utilizacao == 'O');
            } else if (cardOrd == 'comb') {
              let newcurPlateOrigin = [];
              let combOK = {};
              partialCombSeq[sequencial] = partialCombSeq[sequencial] || {};
              curPlateOrigin.forEach((p) => {
                let leftComb = prato_combinacao.filter(
                  (c) => c.COD_PRATO == p.prato || p.gpprato == c.NRGRUPOPRATOSERV,
                );
                leftComb.forEach((c) => {
                  partialCombSeq[sequencial][c.COD_PRATO || c.NRGRUPOPRATOSERV] =
                    partialCombSeq[sequencial][c.COD_PRATO || c.NRGRUPOPRATOSERV] || [];
                  combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV] = combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV]
                    ? combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV]
                    : {
                        ok: true,
                        isPartialCombination: false,
                      };
                  c.SEQ.filter((cseq) => cseq != p.sequencial).forEach((seq) => {
                    if (
                      dia.seq &&
                      Array.isArray(dia.seq[seq]) &&
                      dia.seq[seq].find(
                        (pds) => c.COD_PRATO_COMB == pds.prato || pds.gpprato == c.NRGRUPOPRATOSERV_COMB,
                      )
                    ) {
                      let rightCombAvailable = dia.seq[seq].find(
                        (pds) =>
                          (c.COD_PRATO_COMB == pds.prato || pds.gpprato == c.NRGRUPOPRATOSERV_COMB) &&
                          checkFreqListComparationBool([pds], frequencias, dia),
                      );
                      let seqRightCombIsEmpty = !pratosConfDia.find((pcd) => pcd.sequencial == seq);
                      if (rightCombAvailable && seqRightCombIsEmpty) {
                        if (!this.pratsUsedOnMonth[p.prato] || this.pratsUsedOnMonth[p.prato] < c.mingpFreqComb) {
                          combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates = combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV]
                            .plates
                            ? combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates
                            : [];
                          combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates.push(p);
                          if (combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].ok == false) {
                            combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].isPartialCombination = true;
                          }
                          combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].ok = true;
                        } else if (!combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates || !combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates.length) {
                          if (combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].ok == true) {
                            combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].isPartialCombination = true;
                          }
                          combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].ok = false;
                        }
                      } else if (combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].ok === true) {
                        let hasDishOrGroup = partialCombSeq[sequencial][c.COD_PRATO || c.NRGRUPOPRATOSERV];
                        if (hasDishOrGroup) {
                          partialCombSeq[sequencial][c.COD_PRATO || c.NRGRUPOPRATOSERV].push({ ...c, seq });
                        } else {
                          partialCombSeq[sequencial][c.COD_PRATO || c.NRGRUPOPRATOSERV] = [{ ...c, seq }];
                        }
                      }
                    } else if (
                      cardapio.datas.find((d) =>
                        Object.entries(d.seq).find(
                          (s) =>
                            s[0] == seq &&
                            s[1].find(
                              (pratoDiaQlqer) =>
                                pratoDiaQlqer.prato == c.COD_PRATO_COMB ||
                                pratoDiaQlqer.gpprato == c.NRGRUPOPRATOSERV_COMB,
                            ),
                        ),
                      )
                    ) {
                      combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].ok = false;
                    }
                  });
                });

                leftComb.forEach((c) => {
                  if (
                    combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].ok !== false &&
                    combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates &&
                    combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates.length > 0
                  ) {
                    newcurPlateOrigin = newcurPlateOrigin.concat(combOK[c.COD_PRATO || c.NRGRUPOPRATOSERV].plates);
                  }
                });
                if (!leftComb.length && hasRightAndLeftComb) {
                  newcurPlateOrigin = curPlateOrigin;
                }
              });

              curPlateOrigin = newcurPlateOrigin;
            } else {
              pratos = [];
              curPlateOrigin = [];
            }

            prato = getPratoFromPlateListWithFreq(
              curPlateOrigin,
              frequencias,
              weekNumber,
              gruposSequencial,
              ING_USED,
              dia,
            );

            if (prato && prato.prato) {
              prato.fromPreCard = true;
              pratosConfDia.push(prato);
              pratUsSeq.push(prato.prato);
              grupUsed.push(prato.gpprato);
              logPratos.push(prato);
              let curPartialComb =
                (partialCombSeq[sequencial] &&
                  partialCombSeq[sequencial] &&
                  (partialCombSeq[sequencial][prato.prato] || []).filter((c) => {
                    return c.COD_PRATO == prato.prato;
                  })) ||
                [];
              curPartialComb = curPartialComb.concat(
                (partialCombSeq[sequencial] &&
                  partialCombSeq[sequencial] &&
                  (partialCombSeq[sequencial][prato.gpprato] || []).filter((c) => {
                    return c.NRGRUPOPRATOSERV == prato.gpprato;
                  })) ||
                  [],
              );
              if (Array.isArray(curPartialComb) && curPartialComb.length) {
                let seqsToDelete = curPartialComb.map(({ seq }) => seq);
                seqsToFillEmpty = seqsToFillEmpty.concat(seqsToDelete);
              }
              let currentDay = parseInt(dia.dia.substring(0, 2), 10);
              ING_USED = updateIngUsed(prato, ING_USED, currentDay);

              dia.pratUsSeq = pratUsSeq;
              dia.grupUsed = grupUsed;

              if (prato.MODO_PREPARO && MDPREP_USED.indexOf(prato.MODO_PREPARO) == -1) {
                MDPREP_USED.push(prato.MODO_PREPARO);
              }

              if (prato.TP_CORTE && TPCORT_USED.indexOf(prato.TP_CORTE) == -1) {
                TPCORT_USED.push(prato.TP_CORTE);
              }

              dia.seq = Object.assign({}, dia.seqBKP);
              dia = removeRestrictions(dia, prato, res_prato_combinacao);
              dia.seqBKP = Object.assign({}, dia.seq);
              Frequency.addFrequencyOnMenu(frequencias, prato, weekNumber);
              let comb = prato_combinacao.filter(
                (c) => c.COD_PRATO == prato.prato || prato.gpprato == c.NRGRUPOPRATOSERV,
              );
              if (comb.length > 0) {
                comb.forEach((c) => {
                  let sequenciaisComb = c.SEQ; /* .filter(cseq => !pratosConfDia.find(p => p.sequencial == cseq)) */
                  if (sequenciaisComb.length > 0) {
                    sequenciaisComb.forEach((seqComb) => {
                      if (dia && dia.seq && Array.isArray(dia.seq[seqComb])) {
                        dia.seq[seqComb]
                          .filter((p) => c.COD_PRATO_COMB == p.prato || p.gpprato == c.NRGRUPOPRATOSERV_COMB)
                          .forEach((p) => {
                            p.pratoOrigin = prato.prato;
                            p.utilizacao = 'O';
                          });
                      }
                    });
                  }
                });
              }
            }
          }
        }
        if (seqsToFillEmpty.length) {
          seqsToFillEmpty.forEach((seqToRemove) => {
            let hasDish = pratosConfDia.find((p) => p.sequencial == seqToRemove);
            if (!hasDish) {
              pratosConfDia.push({
                data: dia.dia,
                sequencial: seqToRemove,
                buracoObrigatorio: true,
                isPartialCombination: true,
              });
              dia.seq[seqToRemove] = [];
            } else {
              Object.keys(partialCombSeq).forEach((seq) => {
                if (JSON.stringify(partialCombSeq[seq]) !== '{}') {
                  Object.keys(partialCombSeq[seq]).forEach((dishOrGroup) => {
                    if (partialCombSeq[seq][dishOrGroup].length) {
                      partialCombSeq[seq][dishOrGroup].forEach((comb) => {
                        let { COD_PRATO, COD_PRATO_COMB, NRGRUPOPRATOSERV, NRGRUPOPRATOSERV_COMB } = comb;
                        let leftComb = pratosConfDia.find((p) => {
                          return p.prato == COD_PRATO || p.gpprato == NRGRUPOPRATOSERV;
                        });
                        if (leftComb) {
                          let rightComb = pratosConfDia.find((p) => {
                            return p.prato == COD_PRATO_COMB || p.gpprato == NRGRUPOPRATOSERV_COMB;
                          });
                          if (
                            !rightComb &&
                            !(pratosConfDia.find((p) => p.sequencial == seqToRemove) || {}).buracoObrigatorio
                          ) {
                            let indexDishToRemove = pratosConfDia.findIndex((p) => p.sequencial == seqToRemove);
                            pratosConfDia.push({
                              data: dia.dia,
                              sequencial: seqToRemove,
                              buracoObrigatorio: true,
                              isPartialCombination: true,
                            });
                            if (indexDishToRemove > -1) {
                              let weekNumber = moment(dia.dia, 'DD/MM/YYYY').week();
                              let { gpprato, prato, prods } = pratosConfDia[indexDishToRemove];
                              let hasSameGroupInDay = !!pratosConfDia.find((dish) => dish.gpprato == gpprato);
                              if (!hasSameGroupInDay) {
                                let indexGroupToRemove = dia.grupUsed.findIndex((gp) => gp == gpprato);
                                if (indexGroupToRemove > -1) dia.grupUsed.splice(indexGroupToRemove, 1);
                              }
                              let indexDishUsed = dia.pratUsSeq.findIndex((dishCode) => dishCode == prato);
                              if (indexDishUsed > -1) dia.pratUsSeq.splice(indexDishUsed, 1);
                              let freqs = frequencias.filter(
                                (f) =>
                                  f.COD_PRATO == prato ||
                                  f.NUM_GRP_PRATO == gpprato ||
                                  (f.COD_PRODUTO &&
                                    f.NRGRUPOPRATOSERV == gpprato &&
                                    prods.find((pr) => pr.COD_PRODUTO == f.COD_PRODUTO)),
                              );
                              freqs.forEach((fr) => {
                                if (fr.cur) fr.cur--;
                                if (fr.curWeekUsage && fr.curWeekUsage[weekNumber]) fr.curWeekUsage[weekNumber]--;
                              });
                              pratosConfDia.splice(indexDishToRemove, 1);
                            }
                          }
                        }
                      });
                    }
                  });
                }
              });
            }
          });
        }
        dia.ING_USED = ING_USED;
        dia.MDPREP_USED = MDPREP_USED;
        dia.TPCORT_USED = TPCORT_USED;

        dia.pratos = pratosConfDia;
        dia.pratos.forEach((dish) => {
          MenuAnalytics.analyze(dia.dia, dish.sequencial, dish);
        });
        setPlatesFromConfigOnList(dia, pratosConfDia);
        log.precardData[dia.dia] = (log.precardData[dia.dia] || []).concat(logPratos);
      });
    }
  }
  cardapio.log = log;
  return cardapio;
};

this.addDays = (date, daysToAdd, format = 'DD/MM/YYYY') => {
  let dateMoment = moment(date, format).add(daysToAdd, 'days');
  return { DTDATA: dateMoment.format(format) };
};

this.checkYesterdayAndTomorow = (cardapio, dia, calendario, only2 = false) => {
  let dishes = [];
  const ingredient = {};
  const groups = new Set();
  const groupsWithSeq = new Set();

  if (cardapio.datas.length > 0) {
    let indexOfToday = calendario.findIndex((c) => simpleDate(c.DTDATA) == simpleDate(dia.dia));
    let datesToFilterAndExclude = [];
    const addCalendarDateInArray = (index, array) => {
      if (calendario[index]) {
        array.push(calendario[index]);
      }
    };
    if (only2) {
      addCalendarDateInArray(indexOfToday - 1, datesToFilterAndExclude);
      addCalendarDateInArray(indexOfToday + 1, datesToFilterAndExclude);
      // datesToFilterAndExclude = [this.addDays(dia.dia, -1), this.addDays(dia.dia, 1)];
    } else {
      addCalendarDateInArray(indexOfToday - 3, datesToFilterAndExclude);
      addCalendarDateInArray(indexOfToday - 2, datesToFilterAndExclude);
      addCalendarDateInArray(indexOfToday - 1, datesToFilterAndExclude);

      addCalendarDateInArray(indexOfToday + 1, datesToFilterAndExclude);
      addCalendarDateInArray(indexOfToday + 2, datesToFilterAndExclude);
      addCalendarDateInArray(indexOfToday + 3, datesToFilterAndExclude);
      // datesToFilterAndExclude = [this.addDays(dia.dia, -3), this.addDays(dia.dia, -2), this.addDays(dia.dia, -1), this.addDays(dia.dia, 1), this.addDays(dia.dia, 2), this.addDays(dia.dia, 3) ];
    }

    for (let i = 0; i < datesToFilterAndExclude.length; i++) {
      let curDay = datesToFilterAndExclude[i];

      if (curDay) {
        const curMenu = cardapio.datas.find((cf) => simpleDate(cf.dia) == simpleDate(curDay.DTDATA));
        if (curMenu && curMenu.pratos && curMenu.pratos.length > 0) {
          const { pratos } = curMenu;
          const pratosClone = JSON.parse(JSON.stringify(pratos));
          delete pratosClone.status;
          delete pratosClone.mediaCusto;
          dishes = dishes.concat(pratosClone);
        }
      }
    }
  }
  dishes.forEach((dish) => {
    ingredient[dish.COD_TIP_PRATO] = ingredient[dish.COD_TIP_PRATO] || new Set();
    if(ServiceConfig.hasIngredientValidation(dish.sequencial)) {
      if (dish.INGR_PRINCIPAL_1) {
        ingredient[dish.COD_TIP_PRATO].add(dish.INGR_PRINCIPAL_1);
      }
      if (dish.INGR_PRINCIPAL_2) {
        ingredient[dish.COD_TIP_PRATO].add(dish.INGR_PRINCIPAL_2);
      }
    }
    groups.add(dish.gpprato);
    groupsWithSeq.add(`${dish.sequencial}_${dish.gpprato}`);
  });
  return { dishes, ingredient, groups, groupsWithSeq };
};

let checkFreqListComparationBool = function (newPlateList, frequencias, dia) {
  let week = moment(dia.dia, 'DD/MM/YYYY').week();
  let remaningGps = newPlateList.map((p) => {
    return p.gpprato;
  });
  let posGPS = remaningGps.filter((g) => {
    const groupFrequency = frequencias.find((f) => f.NUM_GRP_PRATO == g);
    if (!groupFrequency) {
      return g;
    }
    if (!groupFrequency.cur && !groupFrequency.curWeekUsage) {
      return g;
    }
    if (Frequency.hasAvailableFrequencyInGroup(groupFrequency, week)) {
      return g;
    }
    return false;
  });
  return posGPS.length > 0;
};

let checkFreqListComparation = function (newPlateList, oldPlateList, frequencias, dia) {
  return checkFreqListComparationBool(newPlateList, frequencias, dia) ? newPlateList : oldPlateList;
};

this.removeExcludedPlates = (dia, dishesInfo, frequencias, { only2 = false, forceRemove = false } = {}) => {
  const { dishes: dishesToRemove, ingredient, groups, groupsWithSeq } = dishesInfo;

  let seq = Object.keys(dia.seq);
  for (let i = 0; i < seq.length; i++) {
    const sequential = seq[i];
    let pratosExc = dishesToRemove.filter((pte) => pte.sequencial == sequential);
    if (only2) {
      dia.seq[sequential] = dia.seq[sequential].filter((dish) => {
        const usedIngredient = ingredient[dish.COD_TIP_PRATO];
        if (!usedIngredient) return true;
        return !usedIngredient.has(dish.INGR_PRINCIPAL_1) && !usedIngredient.has(dish.INGR_PRINCIPAL_2);
      });
      if (forceRemove) {
        let usedGroups = new Set();
        dia.seq[sequential].forEach((p) => usedGroups.add(p.gpprato));
        if (usedGroups.size > 1) {
          let newPratArray = dia.seq[sequential].filter((p) => !groupsWithSeq.has(`${p.sequencial}${p.gpprato}`));
          dia.seq[sequential] = checkFreqListComparation(newPratArray, dia.seq[sequential], frequencias, dia);
        }
      }
    }

    if (only2) {
      let newPratArray = dia.seq[sequential].filter(
        (p) => !dishesToRemove.find((pte) => pte.sequencial == sequential && pte.prato == p.prato),
      );
      dia.seq[sequential] = checkFreqListComparation(newPratArray, dia.seq[sequential], frequencias, dia);
      newPratArray = dia.seq[sequential].filter(
        (p) =>
          !dishesToRemove.find(
            (pte) => pte.sequencial == sequential && (pte.prato == p.prato || pte.gpprato == p.gpprato),
          ),
      );
      dia.seq[sequential] = checkFreqListComparation(newPratArray, dia.seq[sequential], frequencias, dia);
    }
    let dishesCodesToExclude = pratosExc.map(({ prato }) => prato);
    let filtredUniqueDishes = dia.seq[sequential].filter(
      (p) => !dishesCodesToExclude.includes(p.prato) || p.utilizacao == 'O',
    );
    if (only2 && groups.size) {
      let dishesInOtherGroups = filtredUniqueDishes.filter((p) => !groups.has(p.gpprato));
      if (dishesInOtherGroups.length) filtredUniqueDishes = dishesInOtherGroups;
    }
    dia.seq[sequential] = checkFreqListComparation(filtredUniqueDishes, dia.seq[sequential], frequencias, dia);
  }
  return dia;
};

function maxOcurrency(arr) {
  let arrCopy = Object.assign([], arr);
  let item = arrCopy
    .sort((a, b) => arrCopy.filter((v) => v === a).length - arrCopy.filter((v) => v === b).length)
    .pop();

  return arr.filter((a) => a == item).length;
}

function isIntercalable(utilizacaoPratoSemana, cardapio, frequencias, prato_combinacao) {
  let possibleInterspersedSeqs = [];
  let dias = cardapio.datas.length;
  let seqInfo = cardapio.seqInfo;
  let interspersedSeqs = [];
  let seqDetails = {};

  cardapio.datas.forEach((d) => {
    let sequenciais = Object.entries(d.seq);
    sequenciais.forEach((sq) => {
      let seq = sq[0];
      let pratos = sq[1];

      let notInUt =
        utilizacaoPratoSemana.filter((utp) => {
          if (pratos.find((p) => utp.NUM_GRP_PRATO == p.gpprato)) {
            return utp;
          }
        }).length == 0;

      let notInComb =
        prato_combinacao.filter((ptcm) => {
          if (
            pratos.find(
              (p) =>
                ptcm.NRGRUPOPRATOSERV == p.gpprato ||
                ptcm.COD_PRATO == p.prato ||
                ptcm.NRGRUPOPRATOSERV_COMB == p.gpprato ||
                ptcm.COD_PRATO_COMB == p.prato,
            )
          ) {
            return ptcm;
          }
        }).length == 0;

      let notInFr =
        frequencias.filter((f) => {
          if (pratos.find((p) => f.NUM_GRP_PRATO == p.gpprato || f.COD_PRATO == p.prato)) {
            return f;
          }
        }).length == 0;

      let seqOfTwo = seqInfo.find((s) => s.NUM_SEQUENCIA == seq).NUM_GRP_PRATO.length == 2;

      if ((pratos.length == 2 || seqOfTwo) && notInUt && notInFr && notInComb) {
        possibleInterspersedSeqs.push(seq);
        seqDetails[seq] = seqDetails[seq] ? seqDetails[seq] : {};
        seqDetails[seq] = pratos.length == 2 ? 'only2' : 'morePl';
      }
    });
  });

  for (let i = 0; i < possibleInterspersedSeqs.length; i++) {
    let seq = possibleInterspersedSeqs[i];
    if (interspersedSeqs.indexOf(seq) == -1) {
      if (possibleInterspersedSeqs.filter((p) => p == seq).length == dias) {
        interspersedSeqs.push(seq);
      }
    }
  }

  return {
    interspersedSeqs,
    seqDetails,
  };
}

let generateInterspersedDays = (cardapio) => {
  let seqInfo = cardapio.seqInfo;
  let isIntercalableData = cardapio.isIntercalableData;
  let interspersedSeqs = isIntercalableData.interspersedSeqs;
  let seqDetails = isIntercalableData.seqDetails;

  let orderDatas = Object.assign([], cardapio.datas);
  orderDatas.sort((a, b) => {
    if (moment(a.dia, 'DD/MM/YYYY').format('YYYYMMDD') < moment(b.dia, 'DD/MM/YYYY').format('YYYYMMDD')) {
      return -1;
    }
    return 1;
  });

  if (interspersedSeqs.length > 0) {
    for (let j = 0; j < interspersedSeqs.length; j++) {
      let seq = interspersedSeqs[j];
      orderDatas = orderDatas.filter((dia) => !dia.pratos.find((p) => p.sequencial == seq));

      if (seqDetails[seq] == 'only2') {
        let lastPlate = null;

        for (let i = 0; i < orderDatas.length; i++) {
          let curDia = orderDatas[i].dia;

          let prat = null;
          if (!lastPlate) {
            prat = Object.assign({}, cardapio.datas.find((cd) => cd.dia == curDia).seq[seq][0]);
          } else {
            prat = Object.assign(
              {},
              cardapio.datas.find((cd) => cd.dia == curDia).seq[seq].find((p) => p.prato != lastPlate),
            );
          }
          if (prat.prato) {
            prat.fromPreCard = true;
            lastPlate = prat.prato;

            cardapio.datas.find((cd) => cd.dia == curDia).pratos.push(prat);
          }
        }
      } else if (seqDetails[seq] == 'morePl') {
        let pratosUs = [];
        let lastGroup = null;

        let posGP = seqInfo.find((s) => s.NUM_SEQUENCIA == seq).NUM_GRP_PRATO;
        lastGroup = posGP[0];

        for (let i = 0; i < orderDatas.length; i++) {
          let curDia = orderDatas[i].dia;
          let dia = cardapio.datas.find((cd) => cd.dia == curDia);
          let curGP = posGP.find((g) => g != lastGroup);

          let pratos = Object.assign(
            [],
            dia.seq[seq].filter((p) => p.gpprato == curGP),
          );
          if (pratos.length == 0) {
            curGP = lastGroup;
            pratos = Object.assign(
              [],
              dia.seq[seq].filter((p) => p.gpprato == curGP),
            );
          }

          let pratosCod = pratos.map((p) => p.prato);
          let maxOcurrencyVal = maxOcurrency(pratosUs.filter((pu) => pratosCod.includes(pu)));
          let prat = pratos.find((p) => pratosUs.filter((pu) => pu == p.prato).length < maxOcurrencyVal);

          if (!prat) {
            prat = pratos[0];
          }

          if (prat && prat.prato) {
            prat.fromPreCard = true;
            pratosUs.push(prat.prato);
            lastGroup = curGP;

            cardapio.datas.find((cd) => cd.dia == curDia).pratos.push(prat);
          }
        }
      }
    }
  }
  return cardapio;
};

let updateFrequencias = function (cardCong, frequencias, onlyWeek = false) {
  cardCong.cardCong.forEach((dia) => {
    let nSemana = moment(dia.dia, 'DD/MM/YYYY').week();
    frequencias.forEach((freq) => {
      if (freq.MAX_MES_PRD) {
        dia.pratos.forEach((p) => {
          let curFreq = 0;
          if (freq.MAX_MES_PRATO) {
            curFreq = p.prods.filter((pr) => pr.COD_PRODUTO == freq.COD_PRODUTO).length;
          }
          if (curFreq > 0) {
            if (!onlyWeek) {
              freq.cur = freq.cur ? parseInt(freq.cur) + parseInt(curFreq) : parseInt(curFreq);
            }

            freq.curWeekUsage = freq.curWeekUsage || {};
            let weekUsageCount = freq.curWeekUsage[nSemana] || 0;
            freq.curWeekUsage[nSemana] = weekUsageCount + curFreq;
          }
        });
      } else {
        let curFreq = 0;
        if (freq.MAX_MES_PRATO) {
          curFreq = dia.pratos.filter((p) => p.prato == freq.COD_PRATO).length;
        }
        if (freq.MAX_MES_GRP) {
          curFreq = dia.pratos.filter((p) => p.gpprato == freq.NUM_GRP_PRATO).length;
        }

        if (curFreq > 0) {
          if (!onlyWeek) {
            freq.cur = freq.cur ? parseInt(freq.cur) + parseInt(curFreq) : parseInt(curFreq);
          }

          freq.curWeekUsage = freq.curWeekUsage || {};
          let weekUsageCount = freq.curWeekUsage[nSemana] || 0;
          freq.curWeekUsage[nSemana] = weekUsageCount + curFreq;
        }
      }
    });
  });
};

let getGroupsFromConjuntoPorcao = (conjuntoPorcao) => {
  return conjuntoPorcao.map(({ CDGRTIPOPR }) => CDGRTIPOPR);
};

let getTipoPratoRestricaoIngrediente = (restricaoIngrediente) => {
  let tppt = [];
  this.restIng = {};
  restricaoIngrediente.forEach((ri) => {
    let tipoprat = ri.TIPOPRAT.split(';').filter((s) => s.length > 0);
    this.restIng[tipoprat] = this.restIng[tipoprat] || {};
    if (ri['NMINGREDIENTEPRINC'] == 'TODOS') {
      ri.NRINGREDIENTEPRINC = 'XX';
    }
    this.restIng[tipoprat][ri.NRINGREDIENTEPRINC] = {
      INGR_PRINCIPAL_1: ri.INGR_PRINCIPAL_1,
      INGR_PRINCIPAL_2: ri.INGR_PRINCIPAL_2,
      IDDIASEGUIDO: ri.IDDIASEGUIDO,
    };
    tipoprat.forEach((tp) => {
      if (!tppt.includes(tp)) {
        tppt.push(tp);
      }
    });
  });
  return tppt;
};

let removeUnpricedPlates = (cardapio, prc) => {
  cardapio.datas.forEach((dia) => {
    cardapio.seqInfo.forEach((s) => {
      dia.seq[s.NUM_SEQUENCIA] = dia.seq[s.NUM_SEQUENCIA].filter(
        (p) => (s.ATRATIVIDADE == 'ATRATIVIDADE' && p.VRPESOATRATIVIDADE) || prc.find((pr) => pr.COD_PRATO == p.prato),
      );
    });
    dia.pratosBKP = JSON.parse(JSON.stringify(dia.seq));
  });
};

this.generateTonsOfCards = (
  utilizacaoPratoSemana,
  cor,
  cardapio,
  meta,
  prato_combinacao,
  servico,
  res_prato_combinacao,
  complexidade,
  frequencias,
  calendario,
  cardCong,
  lastWeekProds,
  conjuntoPorcao,
  grupoPrato,
  prcConsumoPrato,
  restricaoIngrediente,
  diasCardOrigem,
  sequencialCenarioOriginal,
) => {
  this.grupoPrato = grupoPrato;
  this.prato_combinacao = prato_combinacao;
  this.res_prato_combinacao = res_prato_combinacao;
  this.cdgrtipoprFromPtPrinc = getGroupsFromConjuntoPorcao(conjuntoPorcao);
  this.tipoPratoRestricaoIngrediente = getTipoPratoRestricaoIngrediente(restricaoIngrediente);
  this.ingUsed = new Map();
  removeUnpricedPlates(cardapio, prcConsumoPrato);

  let cardapioFiltrado = {
    mes: cardapio.mes,
    operador: cardapio.operador,
    servico: cardapio.servico,
    unidade: cardapio.unidade,
    datas: [],
  };

  let calendarioFil = Object.assign([], calendario);
  meta.saldoMeta = cardapio.datas.length * meta.VRL_CUSTO_MAX;

  if (lastWeekProds) {
    updateFrequencias(lastWeekProds, frequencias, true);
  }
  if (cardCong) {
    calendarioFil = Object.assign(
      [],
      calendario.filter((c) => !cardCong.datasCong.includes(c.DTDATA)),
    );
    cardapio.datas = cardapio.datas.filter((c) => !cardCong.datasCong.includes(simpleDate(c.dia)));
    meta.saldoMeta = meta.saldoMeta - cardCong.total;
    updateFrequencias(cardCong, frequencias);
  }

  this.pratsUsedOnMonth = {};
  this.pratsUsedOnMonthDAY = [];
  this.melhorPiorCombinação = {};

  if (cardapio.datas.length != 0) {
    cardapio = DataManagement.setPratosFromServOrigem(cardapio, diasCardOrigem);

    cardapio.isIntercalableData = isIntercalable(utilizacaoPratoSemana, cardapio, frequencias, prato_combinacao);

    cardapio = this.generatePreCard(
      utilizacaoPratoSemana,
      cardapio,
      frequencias,
      prato_combinacao,
      calendarioFil,
      res_prato_combinacao,
      lastWeekProds,
    );
    cardapio = generateInterspersedDays(cardapio);
    cardapio.log.diasPosCardOrdem = [];
    cardapio.log.antesPoscard = {};
    cardapio.log.depoisPoscard = {};

    cardapio.datas.forEach((dia) => {
      cardapio.log.diasPosCardOrdem.push(dia.dia);
      tentativasPorDia = 0;

      const dishesToRemoveInfo = this.checkYesterdayAndTomorow(cardapio, dia, calendarioFil);
      if (dishesToRemoveInfo.dishes.length) {
        dia = this.removeExcludedPlates(dia, dishesToRemoveInfo, frequencias);
      }
      const dishesToForceRemoveInfo = this.checkYesterdayAndTomorow(cardapio, dia, calendarioFil, true);
      if (dishesToForceRemoveInfo.dishes.length) {
        dia = this.removeExcludedPlates(dia, dishesToForceRemoveInfo, frequencias, { only2: true, forceRemove: true });
      }

      cardapio.log.antesPoscard[dia.dia] = dia.pratos.map((p) => p);

      let configDia = this.validateConfig(
        cor,
        dia,
        meta,
        prato_combinacao,
        res_prato_combinacao,
        complexidade,
        frequencias,
        conjuntoPorcao,
        sequencialCenarioOriginal,
      );
      setPlatesFromConfigOnList(dia, configDia);
      dia.pratos = JSON.parse(JSON.stringify(configDia));
      dia.logBuracos = DataManagement.logBuracos(dia.pratos, frequencias, dia.seqInfo);

      cardapio.log.depoisPoscard[dia.dia] = configDia.map((p) => p);

      cardapioFiltrado.datas.push({
        logBuracos: dia.logBuracos,
        comenDIV: dia.comenDIV,
        comenCLI: dia.comenCLI,
        comenFUN: dia.comenFUN,
        comenDOA: dia.comenDOA,
        comensais: dia.comensais,
        dia: dia.dia,
        seqInfo: dia.seqInfo,
        diaOrd: moment(dia.dia, 'DD/MM/YYYY').format('YYYYMMDD'),
        mediaCusto: configDia.mediaCusto,
        pratos: configDia,
        ING_USED: dia.ING_USED,
        MDPREP_USED: dia.MDPREP_USED,
        TPCORT_USED: dia.TPCORT_USED,
        ptrsOriginal: dia.ptrsOriginal,
        pratosBKP: dia.pratosBKP,
        buracoObrigatorio: dia.buracoObrigatorio,
      });

      cardapioFiltrado.log = cardapio.log;
      let diasRestantes = cardapio.datas.length - cardapioFiltrado.datas.length;
      meta.saldoMeta = meta.saldoMeta - configDia.mediaCusto;
      diasRestantes = diasRestantes == 0 ? 1 : diasRestantes;

      let newMeta = meta.saldoMeta / diasRestantes;
      if (newMeta > meta.VRL_CUSTO_MAX) {
        meta.cur = meta.VRL_CUSTO_MAX;
      } else {
        meta.cur = newMeta;
      }
    });
  }
  if (cardCong) {
    cardCong.cardCong.forEach((dcg) => {
      cardapioFiltrado.datas.push({
        comenDIV: dcg.comenDIV,
        comenCLI: dcg.comenCLI,
        comenFUN: dcg.comenFUN,
        comenDOA: dcg.comenDOA,
        comensais: dcg.comensais,
        seqInfo: dcg.seqInfo,
        dia: moment(dcg.dia, 'DD/MM/YYYY').format('DD/MM/YYYY'),
        diaOrd: moment(dcg.dia, 'DD/MM/YYYY').format('YYYYMMDD'),
        pratos: dcg.pratos,
        isCongDay: true,
        ING_USED: [],
        MDPREP_USED: [],
        TPCORT_USED: [],
        ptrsOriginal: [],
      });
    });
  }

  return cardapioFiltrado;
};
